---
apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    name: opensearchdashboards-kube
  name: opensearchdashboards-kube
  namespace: logging
spec:
  progressDeadlineSeconds: 600
  replicas: 1
  revisionHistoryLimit: 3
  selector:
    matchLabels:
      name: opensearchdashboards-kube
  strategy:
    rollingUpdate:
      maxSurge: 25%
      maxUnavailable: 25%
    type: RollingUpdate
  template:
    metadata:
      labels:
        name: opensearchdashboards-kube
    spec:
      affinity:
        podAntiAffinity:
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values:
                - opensearchdashboards-kube
            topologyKey: kubernetes.io/hostname
      containers:
      - env:
        - name: OPENSEARCH_HOSTS
          value: http://opensearch-kube-client.logging.svc.cluster.local:9200
        - name: OPENSEARCH_REQUESTTIMEOUT
          value: "30000"
        - name: XPACK_SECURITY_ENABLED
          value: "false"
        - name: TZ
          value: Europe/Paris
        image: registry.gitlab.com/synacksynack/opsperator/docker-opensearchdashboards:master
        imagePullPolicy: Always
        livenessProbe:
          failureThreshold: 10
          initialDelaySeconds: 30
          periodSeconds: 10
          successThreshold: 1
          tcpSocket:
            port: 5601
          timeoutSeconds: 5
        name: opensearchdashboards
        ports:
        - containerPort: 5601
          protocol: TCP
        readinessProbe:
          failureThreshold: 10
          httpGet:
            path: /api/status
            port: 5601
            scheme: HTTP
          initialDelaySeconds: 30
          periodSeconds: 10
          successThreshold: 1
          timeoutSeconds: 5
        resources:
          limits:
            cpu: 1300m
            memory: 1Gi
          requests:
            cpu: 500m
            memory: 512Mi
        securityContext:
          runAsUser: 1000
        volumeMounts:
        - mountPath: /usr/share/opensearch-dashboards/plugins
          name: plugins
      initContainers:
      - command:
        - /bin/bash
        - -c
        - |
          set -xe
          rm -rf plugins/lost+found
          if ! ./bin/opensearch-dashboards-plugin list | grep prometheus-exporter >/dev/null; then
              if ! ./bin/opensearch-dashboards-plugin install "https://github.com/pjhampton/kibana-prometheus-exporter/releases/download/7.10.2/opensearchdashboardsPrometheusExporter-7.10.2.zip"; then
                  echo WARNING: failed to install OpenSearch Dashboards exporter plugin
              fi
          fi
        env:
        - name: OPENSEARCH_HOSTS
          value: http://opensearch-kube-client.logging.svc.cluster.local:9200
        - name: XPACK_SECURITY_ENABLED
          value: "false"
        - name: TZ
          value: Europe/Paris
        image: registry.gitlab.com/synacksynack/opsperator/docker-opensearchdashboards:master
        imagePullPolicy: Always
        name: init
        securityContext:
          runAsUser: 1000
        volumeMounts:
        - mountPath: /usr/share/opensearch-dashboards/plugins
          name: plugins
      nodeSelector:
        node-role.kubernetes.io/infra: "true"
      volumes:
      - emptyDir: {}
        name: plugins
